## org.apache.commons.math3.optimization
Class BaseMultivariateMultiStartOptimizer<FUNC extends MultivariateFunction>

    java.lang.Object
      org.apache.commons.math3.optimization.BaseMultivariateMultiStartOptimizer<FUNC>

Type Parameters:
  `FUNC` - Type of the objective function to be optimized.

All Implemented Interfaces:
  BaseMultivariateOptimizer<FUNC>, BaseOptimizer<PointValuePair>

Direct Known Subclasses:
  DifferentiableMultivariateMultiStartOptimizer, MultivariateDifferentiableMultiStartOptimizer, MultivariateMultiStartOptimizer

Deprecated. As of 3.1 (to be removed in 4.0).

    @Deprecated
    public class BaseMultivariateMultiStartOptimizer<FUNC extends MultivariateFunction>

extends java.lang.Object
implements BaseMultivariateOptimizer<FUNC>

Base class for all implementations of a multi-start optimizer. This interface is mainly intended to enforce the internal coherence of Commons-Math. Users of the API are advised to base their code on `MultivariateMultiStartOptimizer` or on `DifferentiableMultivariateMultiStartOptimizer`.

Since:
  3.0
Version:
  $Id: BaseMultivariateMultiStartOptimizer.java 1422230 2012-12-15 12:11:13Z erans $

Field Summary
`private RandomVectorGenerator` `generator` Deprecated. Random generator for multi-start.
`private int` `maxEvaluations` Deprecated. Maximal number of evaluations allowed.
`private PointValuePair[]` `optima` Deprecated. Found optima.
`private BaseMultivariateOptimizer<FUNC>` `optimizer` Deprecated. Underlying classical optimizer.
`private int` `starts` Deprecated. Number of starts to go.
`private int` `totalEvaluations` Deprecated. Number of evaluations already performed for all starts.

Constructor Summary
`protected` `BaseMultivariateMultiStartOptimizer(BaseMultivariateOptimizer<FUNC> optimizer, int starts, RandomVectorGenerator generator)` Deprecated. Create a multi-start optimizer from a single-start optimizer.

Method Summary
`ConvergenceChecker<PointValuePair>` `getConvergenceChecker()` Deprecated. Get the convergence checker.
`int` `getEvaluations()` Deprecated. Get the number of evaluations of the objective function.
`int` `getMaxEvaluations()` Deprecated. Get the maximal number of function evaluations.
`PointValuePair[]` `getOptima()` Deprecated. Get all the optima found during the last call to `optimize`.
`PointValuePair` `optimize(int maxEval, FUNC f, GoalType goal, double[] startPoint)` Deprecated. Optimize an objective function.
`private void` `sortPairs(GoalType goal)` Deprecated. Sort the optima from best to worst, followed by `null` elements.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### optimizer

    private final BaseMultivariateOptimizer<FUNC extends MultivariateFunction> optimizer

  Deprecated.
  Underlying classical optimizer.

### maxEvaluations

    private int maxEvaluations

  Deprecated.
  Maximal number of evaluations allowed.

### totalEvaluations

    private int totalEvaluations

  Deprecated.
  Number of evaluations already performed for all starts.

### starts

    private int starts

  Deprecated.
  Number of starts to go.

### generator

    private RandomVectorGenerator generator

  Deprecated.
  Random generator for multi-start.

### optima

    private PointValuePair[] optima

  Deprecated.
  Found optima.

Constructor Detail

### BaseMultivariateMultiStartOptimizer

    protected BaseMultivariateMultiStartOptimizer(BaseMultivariateOptimizer<FUNC> optimizer,
                                                  int starts,
                                                  RandomVectorGenerator generator)

  Deprecated.
  Create a multi-start optimizer from a single-start optimizer.

  Parameters:
    `optimizer` - Single-start optimizer to wrap.
    `starts` - Number of starts to perform. If `starts == 1`, the `optimize` will return the same solution as `optimizer` would.
    `generator` - Random vector generator to use for restarts.
  Throws:
    `NullArgumentException` - if `optimizer` or `generator` is `null`.
    `NotStrictlyPositiveException` - if `starts < 1`.

Method Detail

### getOptima

    public PointValuePair[] getOptima()

  Deprecated.
  Get all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
  The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e in ascending order if minimizing and in descending order if maximizing), followed by and null elements corresponding to the runs that did not converge. This means all elements will be null if the `optimize` method did throw an exception. This also means that if the first element is not `null`, it is the best point found across all starts.

  Returns:
    an array containing the optima.
  Throws:
    `MathIllegalStateException` - if `optimize` has not been called.

### getMaxEvaluations

    public int getMaxEvaluations()

  Deprecated.
  Get the maximal number of function evaluations.

  Specified by:
    `getMaxEvaluations` in interface `BaseOptimizer<PointValuePair>`
  Returns:
    the maximal number of function evaluations.

### getEvaluations

    public int getEvaluations()

  Deprecated.
  Get the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

  Specified by:
    `getEvaluations` in interface `BaseOptimizer<PointValuePair>`
  Returns:
    the number of evaluations of the objective function.

### getConvergenceChecker

    public ConvergenceChecker<PointValuePair> getConvergenceChecker()

  Deprecated.
  Get the convergence checker.

  Specified by:
    `getConvergenceChecker` in interface `BaseOptimizer<PointValuePair>`
  Returns:
    the object used to check for convergence.

### optimize

    public PointValuePair optimize(int maxEval,
                                   FUNC f,
                                   GoalType goal,
                                   double[] startPoint)

  Deprecated.
  Optimize an objective function.

  Specified by:
    `optimize` in interface `BaseMultivariateOptimizer<FUNC extends MultivariateFunction>`
  Parameters:
    `maxEval` - Maximum number of function evaluations.
    `f` - Objective function.
    `goal` - Type of optimization goal: either `GoalType.MAXIMIZE` or `GoalType.MINIMIZE`.
    `startPoint` - Start point for optimization.
  Returns:
    the point/value pair giving the optimal value for objective function.

### sortPairs

    private void sortPairs(GoalType goal)

  Deprecated.
  Sort the optima from best to worst, followed by `null` elements.

  Parameters:
    `goal` - Goal type.

Copyright (c) 2003-2013 Apache Software Foundation